{{- $variant := or .variant "mainline" -}}
{{- $architecture := or .architecture "arm64" -}}
{{- $image := or .image (printf "ubuntu-touch-pinetab-%s.img" $architecture) -}}
{{- $cdimagesmirror := or .cdimagesmirror "http://cdimage.ubuntu.com" -}}
{{- $additional_apt_repos := or .additional_apt_repos "" -}}
{{- $phablet_password := or .phablet_password "" }}

---

architecture: {{ $architecture }}
actions:
  - action: recipe
    description: Build pine base
    recipe: focal-pine64-base.yaml
    variables:
      architecture: {{ $architecture }}
      cdimagesmirror: {{ $cdimagesmirror }}
      skip_remove_apt_user: true
      additional_apt_repos: {{ $additional_apt_repos }}

  - action: overlay
    source: pine64/tab-overlay
    description: Adding PT/PT2 overlay
    destination: /

  - action: overlay
    description: Add PT1 bootloader
    source: pine64/files/tab1-boot
    destination: /boot

  - action: overlay
    description: Add PT1 boot patch
    source: pine64/files/uboot-tab1
    destination: /usr/sbin

  - action: run
    chroot: true
    description: Enable u-boot-patch
    command: /bin/systemctl enable /usr/lib/systemd/system-shutdown/u-boot-patch.service

# PHASE 3: build image
  - action: image-partition
    description: Creating image
    imagename: {{ $image }}
    imagesize: 6GB
    partitiontype: gpt
    mountpoints:
      - mountpoint: /
        partition: system
      - mountpoint: /boot
        partition: boot
      - mountpoint: /userdata
        partition: userdata
    partitions:
      - name: loader
        fs: none
        start: 0%
        end: 17MB
      - name: boot
        fs: ext4
        start: 17MB
        end: 300MB
        parttype: C12A7328-F81F-11D2-BA4B-00A0C93EC93B
        flags: [ esp,boot ]
      - name: system
        fs: ext4
        start: 300MB
        end: 5800MB
      - name: userdata
        fs: ext4
        start: 5800MB
        end: 100%
        parttype: B921B045-1DF0-41C3-AF44-4C6F280D3FAE

  - action: filesystem-deploy
    description: Deploying filesystem into image

  - action: run
    chroot: true
    command: update-initramfs -u

  - action: run
    chroot: true
    description: Make sure EXTLINUX is valid + load bootloader
    script: pine64/scripts/zzz-u-boot-tab1

# these guys need to be run at the very end so they don't break anything else
  - action: overlay
    description: Add post inst script for future kernels
    source: pine64/files/last-pine64
    destination: /etc/kernel/postinst.d

  # polish.yaml must be run as the last step, as it contains the
  # step to (re-)create /etc/writable symlinks and systemd-nspawn
  # tends to overwrite them.
  - action: recipe
    description: Run common image polishing steps
    recipe: ../polish.yaml
    variables:
      architecture: {{ $architecture }}
      image: {{ $image }}
      output_type: image
